import { InlineConfig, Plugin } from 'vite';

type DirRoute = {
    dir: string;
    route: string;
};
type Mapper = {
    name: string;
    method: string;
};
type PluginOptions = {
    entry?: string;
    handler?: string;
    dirs?: DirRoute[];
    include?: string[];
    exclude?: string[];
    mapper?: {
        [k: string]: string | false;
    };
    routeBase?: string;
    moduleId?: string;
    outDir?: string;
    minify?: boolean;
    preBuild?: (config: InlineConfig) => InlineConfig;
};
type PluginConfig = {
    moduleId: string;
    root: string;
    routeBase: string;
    entry: string;
    handler: string;
    include: string[];
    exclude: string[];
    dirs: DirRoute[];
    mapper: Mapper[];
    outDir: string;
    minify: boolean;
    preBuild: (config: InlineConfig) => InlineConfig;
};

type FileRouter = {
    name: string;
    file: string;
    path: string;
    route: string;
};

declare const pluginAPI: (apiOptions: PluginOptions) => Plugin;

export { FileRouter, PluginConfig, pluginAPI };
