// src/plugin/runtime/handler.js
import express from "express";
import { routeBase, applyRouters } from "virtual:vite-plugin-api:router";
var handler = express();
var router = express.Router();
handler.use(routeBase, router);
applyRouters(
  (props) => {
    const { method, route, cb } = props;
    if (router[method]) {
      router[method](route, cb);
    } else {
      console.log(method, "Not support!");
    }
  },
  (cb) => async (req, res, next) => {
    if (!res.finished) {
      try {
        let value = await cb(req, res, next);
        if (value) {
          res.send(value);
        }
      } catch (error) {
        next(error);
      }
    }
  }
);
export {
  handler
};
